####################
# Copyright (c) 2008, Perceptive Automation, LLC. All rights reserved.
# http://www.perceptiveautomation.com
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
#
# IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
#
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
# IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
####################

####################
## IMPORTS
import cherrypy
from cherrypy import _cperror

from indigopy import indigoconn as ic
from indigopy import indigodb as idb
from indigopy.basereqhandler import BaseRequestHandler, kTrueStr, kFalseStr, kEmptyStr, kTextPageStr, kHtmlPageStr, kXmlPageStr

# Optional hook to provide a plugin name (will be shown in Event Log)
def PlugInName():
	return u"execAndGo"

# Optional hook called when the IndigoWebServer first connects to IndigoServer
def IndigoConnected():
	pass

# Optional hook called when the IndigoWebServer disconnect from IndigoServer
def IndigoDisconnected():
	pass

class MyRequestHandler(BaseRequestHandler):
	""" Handles HTTP page requests. """

	def __init__(self, logFunc, debugLogFunc):
		BaseRequestHandler.__init__(self, logFunc, debugLogFunc)

	def index(self):
		# Push a log message to Indigo's Event Log window.
		logmessage = "execAndGo usage: http://host:port/execAndGo/execGroup?name=GROUPNAME&page=CONTROLPAGETOGOTO\n"
		logmessage = "\tRemember to put the plus sign (+) in place of spaces in the action group and page names"
		self._Log(logmessage)
		cherrypy.response.headers['Content-Type'] = 'text/plain'
		return logmessage
	index.exposed = True				# exposed = True must be set for handler func to be called

	def execGroup(self, name=None, page=None):
		cherrypy.server.indigoDb.GroupExecute(cherrypy.server.indigoConn, name, "execAndGo.execGroup")
		raise cherrypy.HTTPRedirect("/controlpage?name=" + page)			
	execGroup.exposed = True		# exposed = True must be set for handler func to be called
